	let express    = require('express');
	let exec       = require('child_process').exec;		

	function frontendClean(fileName){
	return new Promise((resolve, reject) => {
			console.log('in frontendClean()');
				//' git fetch origin && git reset --hard origin/master '
				exec('cd ' +  fileName + ' git checkout package.json && npm prune ', (error, stdout, stderr) => {

					if (error) {
						reject(error)
						return;
					}

					console.log(stdout);
					console.log(stderr);
					resolve();
				});
			})

	}


	function frontendPull(fileName){

		return new Promise((resolve, reject) => {
			console.log('in frontendPull()');
				//' git fetch origin && git reset --hard origin/master '
				exec('cd ' +  fileName + ' git checkout package.json && npm prune ' +' && git pull ', (error, stdout, stderr) => {

					if (error) {
						reject(error)
						return;
					}

					console.log(stdout);
					console.log(stderr);
					resolve();
				});
			})
	} 

	function frontendInstallAddons(checkedFiles, downloadFiles){
		console.log('in frontendInstallAddons()');
		return new Promise((resolve, reject) => {

			checkedPlugins = checkedFiles.filter(function(file){
				return /\bexplorviz-frontend-plugin-\w*/.exec(file);
			});

			if(checkedPlugins.length !== 0 ){

				checkedPlugins.forEach((pluginName) => {
					exec('cd ' + ' explorviz-ui-frontend ' + ' ember install ' + downloadFiles[pluginName], (error, stdout, stderr) => {

						if (error) {
							reject(error);
							return;
						}

						console.log(stdout);
						console.log(stderr);

						resolve();

					});

				})
			} else {
				resolve();
			}

		})
	}

	function frontendBuild(fileName){

		return new Promise((resolve,reject)=> {
			console.log('in frontendBuild()');


			exec('cd ' + fileName +' && ember build --environment=production', (error, stdout, stderr) => {

				if (error) {
					reject(error);
					return;
				}

				console.log(stdout);
				console.log(stderr);

				resolve({zipFileName:'frontend', path:'./explorviz-ui-frontend/dist/'});
			});



		})
		console.log('resolve build:', resolve);
	}

	module.exports = {
		frontendClean,
		frontendPull,
		frontendInstallAddons,
		frontendBuild
	}
